// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

// for all others, include the necessary headers (this file is usually all you
// need because it includes almost all <standard< wxWindows headers
#ifndef WX_PRECOMP
    #include <wx/wx.h>

    #include <wx/log.h>
#endif

#include "printwin.h"

// ============================================================================
// implementation
// ============================================================================

// ----------------------------------------------------------------------------
// PrintWin
// ----------------------------------------------------------------------------

void PrintWin::Print(const char* s)
{
	const char* p = s;
	wxString line;
	for(;*p;++p)
	{
		switch(*p)
		{
		// new line
		case '\n':
			PrintPart(line,true);
			line.Truncate(0);
			break;
		// backslash
		case 8:
			if (line.Length() > 0)
				line.Truncate(line.Length()-1);
			break;
		default:
			line += *p;
		}
	}
	if (line.Length() > 0)
		PrintPart(line);
}

void PrintWin::PrintPart(const wxString& s,bool newLine)
{
	dc.DrawText(s,pt.x,pt.y);
	wxCoord w,h;
	dc.GetTextExtent(s,&w,&h);
	
	if (h > maxHInLine)
	   maxHInLine = h;
	
	if (newLine)
	{
		pt.y += maxHInLine ? maxHInLine : lastH;
		pt.x = 0;
		maxHInLine = 0;
	}
	else
	{
		pt.x += w;
	}
	
	// save last for next line
	lastH = h;
}

